<template>
  <div class="detail_contain">
    <p class="now_page_title">我的应用 / 应用仓库 / <span>应用详情</span></p>
    <div class="info_contain">
      <service-header
        :data="service_header_arr"
        @deploy="deploy"
        @editapp="editapp"
        @unline="unline"
        @unsell="unsell"
      ></service-header>
      <div class="type_box">
        <div class="type_title">
          <div
            v-for="(item, index) in service_arr[now_user]"
            :key="index + 1000"
            class="type_select"
            @click="now_service = index"
            :style="
              now_service == index ? { borderBottom: '4px solid #f5ab4c' } : {}
            "
          >
            {{ item }}
          </div>
        </div>
        <div class="type_box_select">
          <!-- <mavon-editor v-model="list_arr" :boxShadow="false" :toolbarsFlag="false" :subfield="subfield" :defaultOpen="preview" :editable="false" v-if="now_service == 0"/> -->
          <info-list
            :list_arr="list_arr"
            v-if="service_arr[now_user][now_service] == '基本信息'"
          >
            <!-- <mavon-editor
              slot="app_code"
              v-model="appcode"
              :boxShadow="false"
              :toolbarsFlag="false"
              :subfield="subfield"
              :defaultOpen="preview"
              :editable="false"
            /> -->
            <div slot="app_code" style="white-space: pre-wrap;background-color:rgb(251,251,251);padding:15px;border-radius:5px;">{{appcode}}</div>
          </info-list>

          <div
            v-if="
              service_arr[now_user][now_service] == '镜像文件管理' &&
                now_user == 0
            "
          >
            <p style="color:#8890a7;">镜像列表：</p>
            <div
              v-if="image_arr"
              class="image_list_container"
              v-infinite-scroll="load_data"
            >
              <apass-table
                :header="header_arr"
                :data="image_arr"
                :padding-left="60"
              ></apass-table>
              <p style="text-align: center;line-height: 36px;" v-if="image_loading">
                加载中...
              </p>
              <p style="text-align: center;line-height: 36px;" v-if="image_noMore">
                没有更多了
              </p>
            </div>
            <p>
              <span class="addimage" @click="addImage">新增镜像</span>
            </p>
            <div v-if="addImageFlag">
              <el-form
                ref="form"
                :rules="rules"
                :model="form"
                label-width="0px"
              >
                <el-form-item prop="name">
                  <p class="formname">镜像名称：</p>
                  <el-input v-model="form.name"></el-input>
                </el-form-item>
                <el-form-item prop="taps">
                  <p class="formname">镜像版本：</p>
                  <el-input v-model="form.taps"></el-input>
                </el-form-item>
                <el-form-item>
                  <p class="formname">上传镜像包：</p>
                  <!-- <upload-file :multiple="false" :max="1" :drag="true" :list="imgList" directory="app" @getNewList="getNewList"></upload-file> -->
                  <el-upload
                    class="upload-demo"
                    drag
                    action="/apaas/hubApi/image/upload"
                    :file-list="form.fileList"
                    ref="upload"
                    :auto-upload="false"
                    :on-success="upload_success"
                    :on-error="upload_error"
                    :data="anotherData"
                    :multiple="false"
                  >
                    <i class="el-icon-upload"></i>
                    <div class="el-upload__text">
                      将文件拖到此处，或<em>点击上传</em>
                    </div>
                  </el-upload>
                </el-form-item>
              </el-form>
            </div>
            <div class="savebtn" v-if="addImageFlag">
              <el-button @click="submit_form('form')">保存</el-button>
              <el-button @click="close_up_image()">取消</el-button>
            </div>
          </div>

          <div
            v-if="
              service_arr[now_user][now_service] == '部署文件管理' &&
                now_user == 0
            "
          >
            <p style="color:#8890a7;">压缩包：</p>
            <p>
              <img
                src="@/assets/imgs/ic_olddata.png"
                alt=""
                style="margin-right: 10px;"
              />{{ oldpag_name }}
              <span class="download" @click="down_load_zip">下载原压缩包</span>
            </p>
            <p style="color:#8890a7;margin:20px 0;">上传新的压缩包：</p>
            <div class="uploadtips">
              <p style="margin-left:-11px;">
                <i class="el-icon-warning-outline"></i>压缩包上传提示：
              </p>
              <p>
                1.必须包含以下文件：Chart.yaml，README.md，step.yaml，values.yaml，logo.png，templates/NOTES.txt；
              </p>
              <p>2.上述文件必须按照上述名称进行命名；</p>
              <p>
                3.step.yaml文件为values.yaml中的可配置参数，templates/NOTES.txt文件为应用的部署信息;
              </p>
              <p>
                4.templates/NOTES.txt主要用于用户部署后的访问,可以按照如下示例进行编写：
              </p>
              <p>&nbsp;&nbsp;&nbsp;this is a postgresql.</p>
              <p>&nbsp;&nbsp;&nbsp;author : Tom</p>
              <p
                v-html="
                  '&nbsp;&nbsp;&nbsp;内部地址： {{ .Release.Name }}.{{ .Release.Namespace }}:5432'
                "
              ></p>
              <p>
                5.请将文件夹压缩为“.zip”、“.tgz”、“.tar.gz”格式，如：名称为redis-ha的文件夹压缩为redis-ha.zip。
              </p>
            </div>
            <el-upload
              class="upload-demo"
              drag
              action="/apaas/hubApi/market/updateChart"
              :file-list="fileList"
              ref="upload1"
              :auto-upload="false"
              :on-success="upload_success"
              :on-error="upload_error"
              :on-change="change_file_state"
              :data="anotherData1"
              :multiple="false"
            >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                将文件拖到此处，或<em>点击上传</em>
              </div>
            </el-upload>
            <div class="savebtn">
              <el-button @click="save_zip">保存</el-button>
              <el-button @click="$router.back(-1)">取消</el-button>
            </div>
          </div>

          <div
            v-if="
              (service_arr[now_user][now_service] == '评分及评论' &&
                now_user == 0) ||
                (service_arr[now_user][now_service] == '评分及评论' &&
                  now_user !== 0)
            "
          >
            <service-tab-comments
              :is_app_detail="is_app_detail"
              :data="commentsData"
              :url="commentsUrl"
            >
            </service-tab-comments>
          </div>
        </div>
      </div>
    </div>
    <dialog-action
      ref="myConfirm"
      :confirmOptions="tipsOptions"
    ></dialog-action>
    <image-detail ref="imageDetail" @refresh="refreshImageList"></image-detail>
  </div>
</template>

<script>
import infoList from "@/components/infoList";
import tableUm from "@/components/table/table-um";
import serviceHeader from "@/components/service-header";
import dialogAction from "@/components/dialog-action";
import uploadFile from "@/components/general/upload_file";
import serviceTabComments from "@/components/service-tabs/service-tab-comments";
import { getRole } from "@/utils/common";
import { mapGetters, mapState } from "vuex";
import apassTable from "@/components/apass-table";
import imageDetail from "@/components/image-detail";
export default {
  components: {
    infoList,
    tableUm,
    serviceHeader,
    dialogAction,
    uploadFile,
    serviceTabComments,
    apassTable,
    imageDetail,
  },
  data() {
    var checkname = (rule, value, callback) => {
      var reg = /^[a-z|-|_]+$/
        setTimeout(() => {
          if (reg.test(value)) {
            callback();
          } else {
            callback(new Error('只支持小写字母 - _'));
          }
        }, 100);
      };
    var checktag = (rule, value, callback) => {
      var reg = /^[a-zA-Z0-9|.]+$/
        setTimeout(() => {
          if (reg.test(value)) {
            callback();
          } else {
            callback(new Error('只支持小写字母 数字 .'));
          }
        }, 100);
      };
    return {
      now_user: 0, //0：普通用户，1：组织管理员，2：超级管理员
      buy_style: 0,
      image_loading: false,
      image_noMore: false,
      preview: "preview",
      subfield: false,
      image_arr: [],
      now_page: 1,
      total: 0,
      anotherData: {},
      anotherData1: {},
      asynLoad: false,
      oldpag_name: "",
      imgList: [],
      imgList1: [],
      is_app_detail: true,
      commentsData: {
        avgScore: 0,
        scoreStatic: {},
      },
      commentsUrl: "",
      form: {
        name: "",
        fileList: [],
        taps: "",
      },
      fileList: [],
      rules: {
        name: [{ required: true, message: "请输入镜像名称", trigger: "blur" },
                { max:20, message: "应小于20个字符", trigger: 'blur' },
                {validator: checkname, trigger: 'blur' }
              ],
        taps: [
          { required: true, message: "请输入镜像版本", trigger: "blur" },
          { max:10, message: "应小于10个字符", trigger: 'blur' },
          { validator: checktag, trigger: "blur" },
        ],
      },
      tipsOptions: {
        title: "",
        message: "",
        btnSubmitText: "",
        btnCancelText: "",
        position: "",
      },
      service_arr: [
        ["基本信息", "镜像文件管理", "部署文件管理"],
        ["基本信息"],
        ["基本信息"],
      ],
      service_header_arr: {
        name: "",
        first: [
          {
            name: "在线状态",
            text: "",
          },
          {
            name: "应用类型",
            text: "",
          },
          {
            name: "业务领域",
            text: "",
          },
        ],
        second: [
          {
            name: "申请类型",
            text: "",
          },
          {
            name: "申请开发次数",
            text: "",
          },
          {
            name: "申请部署次数",
            text: "",
          },
          {
            name: "创建时间",
            text: "",
          },
        ],
        yydetail: "",
        xxdetail: "",
        aqdetail: true,
        fxdetail: false,
        url: "",
      },
      now_service: 0,
      header_arr: [],

      list_arr: [
        {
          title: "应用简介：",
          info: "",
        },
        {
          title: "功能简介：",
          info: "",
        },
        {
          title: "应用场景：",
          info: "",
        },
        {
          title: "应用参数：",
          info: "",
          type: "solt",
          solt_name: "app_code",
        },
      ],
      appcode: "",
      addImageFlag: false,
    };
  },
  computed: {
    ...mapGetters(["level"]),
    ...mapState(["userInfo"]),
  },
  watch: {},
  created() {
    console.log(this.$route);
    if (this.userInfo) {
      this.now_user = this.level;
      this.getServiceInfo();
    } else {
      this.getCurrentUser();
    }
    this.asynLoad = false;
    this.commentsUrl = `/apaas/hubApi/market/comments/${this.$route.params.id}`;
    this.getServiceBaseInfo();
    this.get_image_list();
    this.get_options();
    this.get_file_name();
    this.get_app_code();
  },
  mounted() {
    this.header_arr = [
      {
        prop: "name",
        label: "镜像名称",
        minWidth: "33.33%",
        align: "center",
        type: "button",
        callback: this.showImageDetail,
      },
      {
        prop: "tag",
        label: "版本数",
        minWidth: "33.33%",
        align: "center",
      },
      {
        label: "操作",
        type: "buttons",
        align: "center",
        minWidth: "33.33%",
        actionList: [
          {
            label: "删除",
            class: "warn",
            callback: this.actiondelete,
          },
        ],
      },
    ];
  },
  methods: {
    showImageDetail(item) {
      this.$refs.imageDetail.showDialog({
        ...item,
        app_id: this.$route.params.id
      });
    },
    getCurrentUser() {
      this.$api.user.getNowUser().then(({ data }) => {
        if (data.success == 1) {
          console.log("--- user info ---");
          console.log(data.data);
          console.log("--- user info ---");
          this.$store.commit("userInfofun", data.data);
          this.now_user = this.level;
          this.getServiceInfo();
          console.log(this.level);
        } else {
          console.log(data.errMsg);
        }
      });
    },
    addImage() {
      this.addImageFlag = true;
    },
    down_load_zip() {
      const a = document.createElement("a"); // 创建a标签
      a.setAttribute("download", ""); // download属性
      a.setAttribute(
        "href",
        "/apaas/hubApi/market/download/" + this.$route.params.id
      ); // href链接
      a.click(); // 自执行点击事件
    },
    get_options() {
      this.$http
        .get(
          `/apaas/hubApi/market/comments/${this.$route.params.id}?limit=10&page=1`
        )
        .then((response) => {
          if (response.data.success == 1) {
            console.log(response);
            var temp = {};
            response.data.data.overview.detail_counts.forEach((e) => {
              temp[e.score] = e.count;
            });
            this.commentsData = {
              avgScore: response.data.data.overview.ave,
              scoreStatic: temp,
            };
          }
        });
    },
    submit_form(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.anotherData = {
            image_name: this.form.name,
            tag: this.form.taps,
            app_id: this.$route.params.id,
          };
          console.log(this.anotherData);
          setTimeout(() => {
            this.$refs["upload"].submit();
            this.$message.success("开始上传");
            this.$refs["form"].resetFields();
            // this.addImageFlag = false
          });
        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
    close_up_image() {
      this.$refs["form"].resetFields();
      this.addImageFlag = false;
    },
    save_zip() {
      this.anotherData1 = {
        app_id: this.$route.params.id,
      };
      console.log(this.anotherData1);
      setTimeout(() => {
        this.$refs["upload1"].submit();
      });
    },
    upload_success(response, file, fileList) {
      if (response.success == 1) {
        this.addImageFlag = false;
        this.$message.success("上传成功");
        this.now_page = 1;
        this.image_arr = [];
        this.get_image_list();
        this.get_file_name();
      } else {
        this.$message.error(response.errMsg);
      }
    },
    change_file_state(file,fileList){
      console.log(file,fileList);
      if(fileList.length>=2){
        this.fileList = [file]
      }
    },
    upload_error() {
      this.$message.error("上传失败");
    },
    load_data() {
      this.asynLoad = false;
      if (5 * this.now_page < this.total) {
        this.now_page = this.now_page + 1;
        this.get_image_list();
      } else if (this.total > 0) {
        this.image_noMore = true;
      }
    },
    get_image_list() {
      this.image_loading = true;
      this.$http
        .get(
          `/apaas/hubApi/image/imageUpList?page=${this.now_page}&size=5&app_id=${this.$route.params.id}`
        )
        .then((response) => {
          if (response.data.success == 1) {
            console.log(response);
            this.asynLoad = true;
            if (response.data.data && response.data.data.length) {
              this.image_arr.push(...response.data.data);
            } else {
              this.image_arr = [];
            }
            this.total = response.data.total;
            this.image_loading = false;
            this.image_noMore = false;
          }
        });
    },
    get_file_name() {
      this.$http
        .get(`/apaas/hubApi/market/chartsName/${this.$route.params.id}`)
        .then((response) => {
          if (response.data.success == 1) {
            console.log(response);
            this.oldpag_name = response.data.data;
          }
        });
    },
    delete_data(name) {
      this.$http
        .delete(`/apaas/hubApi/image/del/${name}?app_id=${this.$route.params.id}`)
        .then((response) => {
          if (response.data.success == 1) {
            this.$message.success("删除成功");
            this.refreshImageList();
          } else {
            this.$message.error("删除失败");
          }
        })
        .catch(() => {
          this.$message.error("删除失败");
        });
    },
    actiondelete(n) {
      console.log(n);
      this.tipsOptions = {
        title: "",
        message: "",
        btnSubmitText: "",
        btnCancelText: "",
        position: "",
      };
      this.tipsOptions.message = "是否删除该镜像？";
      this.tipsOptions.confirmSubmit = () => {
        console.log("deleteItem - ");
        this.delete_data(n.name);
        this.$refs.myConfirm.hideModel();
      };
      this.$refs.myConfirm.showModel();
    },
    change_up_state(url, state) {
      this.$http
        .put(`${url}/${this.$route.params.id}/${state}`)
        .then((response) => {
          if (response.data.success == 1) {
            this.$message.success("申请成功");
            setTimeout(() => {
              this.getServiceInfo();
            }, 1000);
          } else {
            this.$message.error("申请失败");
          }
        })
        .catch((res) => {
          this.$message.error("申请失败");
        });
    },
    deploy() {
      console.log("0000");
    },
    editapp() {
      this.$router.push(
        `${this.$route.path.split("detail")[0]}edit/${this.$route.params.id}`
      );
    },
    unline(val) {
      console.log(val);
      this.tipsOptions = {
        title: "",
        message: "",
        btnSubmitText: "",
        btnCancelText: "",
        position: "",
      };
      if (val.xxdetail == "申请下线" || val.xxdetail == "申请下线d") {
        this.tipsOptions.message =
          "该操作会将该应用从应用商店的平台应用区域下线至开发者应用区域，下线前需向超级管理员发送通知，超级管理员通过后此应用将下线至开发者应用区域。";
        this.tipsOptions.btnSubmitText = "发送通知";
      }
      if (val.xxdetail == "申请上线" || val.xxdetail == "申请上线d") {
        this.tipsOptions.message =
          "该操作会将该应用从应用商店开发者应用上线至平台应用";
        this.tipsOptions.btnSubmitText = "确认";
      }
      this.tipsOptions.position = "left";
      this.tipsOptions.confirmSubmit = () => {
        console.log("deleteItem - ");
        if (val.xxdetail == "申请下线" || val.xxdetail == "申请下线d") {
          this.change_up_state("/apaas/hubApi/market/platformStatus", 3);
        }
        if (val.xxdetail == "申请上线" || val.xxdetail == "申请上线d") {
          this.change_up_state("/apaas/hubApi/market/platformStatus", 1);
        }
        this.$refs.myConfirm.hideModel();
      };
      this.$refs.myConfirm.showModel();
    },
    unsell(val) {
      console.log(val);
      this.tipsOptions = {
        title: "",
        message: "",
        btnSubmitText: "",
        btnCancelText: "",
        position: "",
      };
      if (val.yydetail == "申请下架" || val.yydetail == "申请下架d") {
        this.tipsOptions.message =
          "申请下架应用需要向组织管理员发送通知，组织管理员通过下架请求后该应用将从应用商店下架。";
        this.tipsOptions.btnSubmitText = "发送通知";
      }
      if (val.yydetail == "申请上架" || val.yydetail == "申请上架d") {
        this.tipsOptions.message =
          "申请下架应用需要向组织管理员发送通知，组织管理员通过上架请求后该应用将在应用商店上架。";
        this.tipsOptions.btnSubmitText = "确认";
      }
      this.tipsOptions.confirmSubmit = () => {
        console.log("deleteItem - ");
        if (val.yydetail == "申请下架" || val.yydetail == "申请下架d") {
          this.change_up_state("/apaas/hubApi/market/deployStatus", 3);
        }
        if (val.yydetail == "申请上架" || val.yydetail == "申请上架d") {
          this.change_up_state("/apaas/hubApi/market/deployStatus", 1);
        }
        this.$refs.myConfirm.hideModel();
      };
      this.$refs.myConfirm.showModel();
    },
    getServiceInfo() {
      this.$http
        .get("/apaas/hubApi/market/baseInfo?id=" + this.$route.params.id)
        .then((response) => {
          if (response.data.success) {
            let data = response.data.data;
            var temp_info = {
              name: data.app_name + " " + data.version,
              first: [
                {
                  name: "在线状态",
                  text: data.online_state_name,
                },
                {
                  name: "应用类型",
                  text: data.type_name,
                },
                {
                  name: "业务领域",
                  text: data.ywly_name,
                },
              ],
              second: [
                {
                  name: "申请类型",
                  text: data.apply_type_name,
                },
                {
                  name: "申请开发次数",
                  text: data.apply_times + "次",
                },
                {
                  name: "申请部署次数",
                  text: data.deploy_times + "次",
                },
                {
                  name: "创建时间",
                  text: data.create_date,
                },
              ],
              yydetail: "",
              xxdetail: "",
              aqdetail: true,
              fxdetail: false,
              url: "",
            };
            if (data.apply_type_name) {
            } else {
              temp_info["second"].splice(0, 1);
            }
            var show_arr = [
              [[["申请上架"]], [["申请上架d"]]],
              [
                "",
                "",
                [["申请下架", "申请上线"], ["申请上线d"]],
                [["申请上架d"]],
              ],
              ["", "", ["", "", ["申请下线"], ["申请下线d"]]],
            ];
            var temp_str =
              show_arr[data.online_state] &&
              show_arr[data.online_state][data.up_deploy_status] &&
              show_arr[data.online_state][data.up_deploy_status][
                data.up_platform_status
              ]
                ? show_arr[data.online_state][data.up_deploy_status][
                    data.up_platform_status
                  ]
                : "";
            if (this.$route.query.source == "apply") {
              if (this.now_user == 0 || this.now_user == 4) {
                this.service_arr[0].splice(1, 2);
              }
            } else {
              if (temp_str && temp_str[0] && temp_str[0].indexOf("架") !== -1) {
                temp_info.yydetail = temp_str[0];
              }
              if (temp_str && temp_str[1] && temp_str[1].indexOf("架") !== -1) {
                temp_info.yydetail = temp_str[1];
              }
              if (temp_str && temp_str[0] && temp_str[0].indexOf("线") !== -1) {
                temp_info.xxdetail = temp_str[0];
              }
              if (temp_str && temp_str[1] && temp_str[1].indexOf("线") !== -1) {
                temp_info.xxdetail = temp_str[1];
              }
            }
            if (
              data.online_state == 1 &&
              data.up_deploy_status == 2 &&
              data.up_platform_status == 0
            ) {
              this.service_arr[this.now_user].push("评分及评论");
            }
            if (this.now_user == 0) {
              temp_info.fxdetail = true;
            }
            if (this.now_user == 1) {
              temp_info.xxdetail = "";
              temp_info.yydetail = "";
              temp_info.fxdetail = "";
              temp_info.aqdetail = false;
            }
            if (this.now_user == 2) {
              temp_info.xxdetail = "";
              temp_info.yydetail = "";
              temp_info.aqdetail = true;
            }
            temp_info.url = data.logo;
            this.service_header_arr = temp_info;
          }
        })
        .catch(function(response) {});
    },

    getServiceBaseInfo() {
      this.$http
        .get("/apaas/hubApi/market/app/detail/" + this.$route.params.id)
        .then((response) => {
          let data = response.data.data;
          this.$set(this.list_arr[0], "info", data.yyjj);
          this.$set(this.list_arr[1], "info", data.gnjj);
          this.$set(this.list_arr[2], "info", data.cjsl);
        })
        .catch(function(response) {});
    },
    get_app_code() {
      this.$http
        .get("/apaas/hubApi/market/values/" + this.$route.params.id)
        .then((response) => {
          let data = response.data.data;
          this.appcode = data;
        })
        .catch(function(response) {});
    },
    refreshImageList() {
      this.now_page = 1;
      this.image_arr = [];
      this.get_image_list();
    }
  },
};
</script>

<style>
.savebtn .el-button {
  float: right;
  margin-left: 20px;
  letter-spacing: 2px;
}
.savebtn .el-button:nth-of-type(1) {
  background-color: #0f2683;
  color: #f8f9fd;
}
.savebtn .el-button:nth-of-type(2) {
  background-color: #c3caf8;
  color: #0f2683;
}
</style>
<style scoped>
.detail_contain {
  width: 100%;
  padding: 0 20px;
  height: calc(100% - 55px);
}
.info_contain {
  padding: 25px 20px;
  background-color: #fff;
  width: 100%;
  box-shadow: 0px 3px 6px 0px #f4f7fc;
  border-radius: 12px;
  min-height: calc(100% - 20px);
  margin-bottom: 20px;
}
.now_page_title {
  margin: 15px 0;
  color: #898d9e;
}
.now_page_title span {
  color: #242c43;
}
.type_box {
  width: 100%;
}
.type_title {
  width: 100%;
  height: 65px;
  line-height: 65px;
  border-bottom: 2px solid #f4f7fc;
}
.type_select {
  float: left;
  width: auto;
  margin-right: 40px;
  height: 65px;
  cursor: pointer;
}
.type_box_select {
  padding: 30px 10px 10px 10px;
  width: 100%;
}

.savebtn {
  margin-top: 50px;
  overflow: hidden;
}
.appcode {
  white-space: pre-wrap;
  width: 100%;
  background-color: #f8f9fd;
  border-radius: 8px;
  padding: 24px;
  color: #58617a;
}
.addimage,
.download {
  display: inline-block;
  color: #f8f9fd;
  font-size: 16px;
  width: 124px;
  height: 44px;
  line-height: 44px;
  text-align: center;
  background-color: #0f2683;
  border-radius: 8px;
  margin-top: 20px;
  cursor: pointer;
}
.download {
  background-color: #495feb;
  margin-left: 10px;
}
.formname {
  color: #8890a7;
}
.uploadtips {
  width: 750px;
  background-color: #f8f9fd;
  border-radius: 8px;
  padding: 20px 40px;
  color: #8890a7;
  line-height: 22px;
  margin-bottom: 20px;
}
.image_list_container {
  height: 284px;
  overflow-y: auto;
}
</style>
